//DIREKTHILFE SPEZIELL FUER SCHICKARD

import com.sun.j3d.utils.behaviors.picking.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.media.j3d.*;
import javax.vecmath.*;

import java.awt.Cursor;
import java.awt.TextArea;

public class PickHelp extends Behavior {
  
  protected PickObject pickScene;
  protected WakeupOnAWTEvent moveCriterion;
  protected boolean buttonPress = false;
  protected boolean test = false;  
  protected MouseEvent mevent;
  private Canvas3D canvas;
  private TextArea textArea;
  private Object objTemp;
  private Cursor helpCursor;

  public PickHelp(BranchGroup root, Canvas3D canvas, Bounds bounds, TextArea textArea, Cursor helpCursor) {
    super();
    pickScene = new PickObject(canvas, root);
    this.canvas = canvas;
    this.setSchedulingBounds(bounds);
    this.textArea = textArea;
    this.helpCursor = helpCursor;
  }

  public void initialize() {
    moveCriterion = new WakeupOnAWTEvent(MouseEvent.MOUSE_MOVED);//ALT: Event.MOUSE_MOVE
    wakeupOn(moveCriterion);
  }
  
  private void processMouseEvent(MouseEvent evt) {
    buttonPress = false;

    if (evt.getID()==MouseEvent.MOUSE_PRESSED |
	evt.getID()==MouseEvent.MOUSE_CLICKED |
	evt.getID()==MouseEvent.MOUSE_DRAGGED) {
      buttonPress = true;
      return;
    }
  }
  
  public void processStimulus (Enumeration criteria) {
    WakeupCriterion wakeup;
    AWTEvent[] evt = null;
    int xpos = 0, ypos = 0;

    while(criteria.hasMoreElements()) {
      wakeup = (WakeupCriterion)criteria.nextElement();
      if (wakeup instanceof WakeupOnAWTEvent)
	evt = ((WakeupOnAWTEvent)wakeup).getAWTEvent();
    }
    
    if (evt[0] instanceof MouseEvent){
      mevent = (MouseEvent) evt[0];

      processMouseEvent((MouseEvent)evt[0]);
      xpos = mevent.getPoint().x;
      ypos = mevent.getPoint().y;

      updateScene(xpos, ypos);
    }
     
    wakeupOn (moveCriterion);
  }

  public void updateScene(int xpos, int ypos) {

   test = false;
   SceneGraphPath path = pickScene.pickClosest(xpos, ypos, PickObject.USE_GEOMETRY);

   if (path != null) {
     for (int i = 0; i < path.nodeCount(); i++) {
        objTemp = path.getNode(i).getUserData();
           if (objTemp instanceof CheckID) {

	     test = true;
	     String name = ((CheckID) objTemp).getID1();
	     int number = ((CheckID) objTemp).getID2();
             canvas.setCursor(SceneViewer3D.hand_cursor);
	     
	     if (name == Schickard.rotateID) {
	       if (number < 7)//ZYLINDER 1-6
	        textArea.setText("Here you can change the " + number + ". digit of the number that is displayed in the first line.\n"
		 	       + "LEFT-CLICK: Turn cylinder clockwise,\n" + "RIGHT-CLICK: Turn cylinder anticlockwise,\n"
			       + "MIDDLE-BUTTON: Zoom in/out.\n"
                               + "GOOD VIEW TO SEE THE NUMBERS: Front View or Top View");
               else//MEMORY 7-12
                textArea.setText("Here you can change the " + (number-6) + ". digit of the number that is stored in the memory discs.\n"
			      + "LEFT-CLICK: Turn memory disc clockwise.\n" + "RIGHT-CLICK: Turn anticlockwise,\n"
			      + "MIDDLE-BUTTON: Zoom in/out.\n"
			      + "GOOD VIEW TO SEE THE NUMBERS: Bird View.");
	     }
             else if (name == Schickard.calcID) {//0-5
	       int j = (int) Math.pow(10, number);
	       textArea.setText("Here you can turn the " + (number+1) + ". wheel of the adding machine.\n"
			      + "LEFT-CLICK: Add " + j + " to the current number,\n" + "RIGHT-CLICK: Subtract " + j + " from the current number,\n"
 			      + "MIDDLE-BUTTON: Zoom in/out.\n"	
			      + "GOOD VIEW TO SEE THE NUMBERS: Bird View.");	       
	     }
             else if (name == Schickard.moveID) {//2-9
	       textArea.setText("Here you can move the " + number + ". slide by HOLDING DOWN THE LEFT BUTTON.\n"
			      + "SLIDE AT TOTAL LEFT: Small Windows are fully visible for calculation.\n"
			      + "SLIDE AT TOTAL RIGHT: Small Windows are covered.\n"
			      + "MIDDLE-BUTTON: Zoom in/out  -  RIGHT-BUTTON: Move the whole machine.\n"
			      + "GOOD VIEW TO MOVE THE SLIDES: Front View or Top View.");
	     }
          }
     }      
  }

  if (!test) {
    if (!buttonPress)
      canvas.setCursor(helpCursor);
     
    textArea.setText("This is not a part of the calculator you can modify.\n"
                   + "HOLD DOWN LEFT BUTTON: Rotate the whole machine,\n"
                   + "HOLD DOWN MIDDLE BUTTON: Zoom in or out,\n"
                   + "HOLD DOWN RIGHT BUTTON: Move the whole machine.");
  }  
 }
}

