//Spezielles PickingBehavior, das nur einen bestimmten Knoten aendert, falls
//nichts oder nur ein 1-elementiger Pfad gepickt wurde

//Version D (mit neuem Cursorveraendern und MouseRotate0Behavior, das direkt dreht ohne zu verschieben)

//TODO: IMPROVE

import com.sun.j3d.utils.behaviors.picking.*;
import com.sun.j3d.utils.behaviors.mouse.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.media.j3d.*;
import javax.vecmath.*;

public class PickRotateSpecial extends Behavior implements MouseBehaviorCallback {
  protected PickObject pickScene;
  protected WakeupOnAWTEvent pressCriterion;
  protected boolean buttonPress = false;
  protected TransformGroup currGrp;
  protected static final boolean debug = false;
  protected MouseEvent mevent;
   
  MouseRotate0 drag;
  int pickMode = PickObject.USE_BOUNDS;
  private PickingCallback callback=null;
  private TransformGroup currentTG;
  private TransformGroup specialGroup;

  private Canvas3D canvas;
  private Cursor rotateCursor;

  public PickRotateSpecial(BranchGroup root, Canvas3D canvas, Bounds bounds, TransformGroup specialTrafoGroup, Cursor rotateCursor){
    super();
    currGrp = new TransformGroup();
    currGrp.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
    currGrp.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
    root.addChild(currGrp);
    pickScene = new PickObject(canvas, root);
     
    drag = new MouseRotate0(MouseRotate0.MANUAL_WAKEUP);
    currGrp.addChild(drag);
    drag.setTransformGroup(specialTrafoGroup);
    drag.setSchedulingBounds(bounds);
    this.setSchedulingBounds(bounds);
    specialGroup = specialTrafoGroup;
    currentTG = specialTrafoGroup;
     
    this.canvas = canvas;
    this.rotateCursor = rotateCursor;     
  }

  public PickRotateSpecial(BranchGroup root, Canvas3D canvas, Bounds bounds, 
		           int pickMode, TransformGroup specialTrafoGroup, Cursor rotateCursor){
    super();
    currGrp = new TransformGroup();
    currGrp.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
    currGrp.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
    root.addChild(currGrp);
    pickScene = new PickObject(canvas, root);
     
    drag = new MouseRotate0(MouseRotate0.MANUAL_WAKEUP);
    currGrp.addChild(drag);     
    drag.setTransformGroup(specialTrafoGroup);
    drag.setSchedulingBounds(bounds);
    this.setSchedulingBounds(bounds);
    this.pickMode = pickMode;
    specialGroup = specialTrafoGroup;
    currentTG = specialTrafoGroup;
     
    this.canvas = canvas;
    this.rotateCursor = rotateCursor;     
  }

  /**
   * Sets the pickMode component of this PickRotateBehavior to the value of
   * the passed pickMode.
   * @param pickMode the pickMode to be copied.
   **/

  public void setPickMode(int pickMode) {
    this.pickMode = pickMode;
  }

 /**
   * Return the pickMode component of this PickRotateBehavior.
   **/ 

  public int getPickMode() {
    return pickMode;
  }
     
  public void initialize() {
    pressCriterion = new WakeupOnAWTEvent(MouseEvent.MOUSE_PRESSED);
    wakeupOn(pressCriterion);
  }
  
  private void processMouseEvent(MouseEvent evt) {
    buttonPress = false;

    if (evt.getID()==MouseEvent.MOUSE_PRESSED) {//| == MouseEvent.MOUSE_CLICKED (WEGGELASSEN)
      buttonPress = true;
      return;
    }
  }

//NEU: Ueberschreibe folgende Funktion aus PickMouseBehavior wegen obigem processMouseEvent
  public void processStimulus (Enumeration criteria) {
    WakeupCriterion wakeup;
    AWTEvent[] evt = null;
    int xpos = 0, ypos = 0;

    while(criteria.hasMoreElements()) {
      wakeup = (WakeupCriterion)criteria.nextElement();
      if (wakeup instanceof WakeupOnAWTEvent)
	evt = ((WakeupOnAWTEvent)wakeup).getAWTEvent();
    }
    
    if (evt[0] instanceof MouseEvent){
      mevent = (MouseEvent) evt[0];

      if (debug)
	System.out.println("got mouse event");
      processMouseEvent((MouseEvent)evt[0]);   
       
      xpos = mevent.getPoint().x;
      ypos = mevent.getPoint().y;
    }
    
    if (debug)
      System.out.println("mouse position " + xpos + " " + ypos);
    
    if (buttonPress){
      updateScene(xpos, ypos);
    }
    wakeupOn (pressCriterion);
  }

  /**
   * Update the scene to manipulate any nodes. This is not meant to be 
   * called by users. Behavior automatically calls this. You can call 
   * this only if you know what you are doing.
   * 
   * @param xpos Current mouse X pos.
   * @param ypos Current mouse Y pos.
   **/
  public void updateScene(int xpos, int ypos){
    TransformGroup tg = null;
    
    if (!mevent.isMetaDown() && !mevent.isAltDown()){
      SceneGraphPath path = pickScene.pickClosest(xpos, ypos, pickMode);
       
      if ((path == null) || (path.nodeCount() == 1))
	 {	    
	  canvas.setCursor(rotateCursor);
	  drag.setTransformGroup(specialGroup);//Wegen Reset!
 	  drag.wakeup();
	 }
      else if (callback!=null)
	     callback.transformChanged( PickingCallback.NO_PICK, null );
    }
  }

  /**
    * Callback method from MouseRotate0
    * This is used when the Picking callback is enabled
    */
  public void transformChanged( int type, Transform3D transform ) {
      callback.transformChanged( PickingCallback.ROTATE, currentTG );
  }
 
  /**
    * Register the class @param callback to be called each
    * time the picked object moves
    */
  public void setupCallback( PickingCallback callback ) {
      this.callback = callback;
      if (callback==null)
          drag.setupCallback( null );
      else
          drag.setupCallback( this );
  }
}

