//Allgemeiner 3D-SzeneViewer mit interaktiver Mausbedienung
//Endversion 2

//TODO: OHNE GLOBALTRAFO?????
//(TODO: Wieviele IMPORTS?)

import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import com.sun.j3d.utils.behaviors.picking.*;
import com.sun.j3d.utils.universe.*;
import javax.media.j3d.*;
import javax.vecmath.*;

public class SceneViewer3D extends Canvas3D{

    public static final Cursor hand_cursor = new Cursor(Cursor.HAND_CURSOR);
    public static final Cursor move_cursor = new Cursor(Cursor.MOVE_CURSOR);
    public static final Cursor zoom_cursor = new Cursor(Cursor.N_RESIZE_CURSOR);
    public static final Cursor default_cursor = new Cursor(Cursor.DEFAULT_CURSOR);
   
    private BranchGroup userScene;
    private BranchGroup globalRoot;
    private TransformGroup globalTrafo;
    private SimpleUniverse u;
    private TransformGroup vpTrans;   
   
    public SceneViewer3D() {
        super(SimpleUniverse.getPreferredConfiguration());
       
        //Erstelle neue Wurzel des Szenengraphen
        globalRoot = new BranchGroup();
        userScene = new BranchGroup();
              
        //Fge Transformationsknoten ein
        globalTrafo = new TransformGroup();
	globalTrafo.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
        globalTrafo.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
        globalTrafo.setCapability(TransformGroup.ENABLE_PICK_REPORTING);
        globalRoot.addChild(globalTrafo);
       
        //Haenge userScene-Knoten darunter
        globalTrafo.addChild(userScene);
	   
        //Erstelle SimpleUniverse und initialisiere Kamera
        u = new SimpleUniverse(this);
        u.getViewingPlatform().setNominalViewingTransform();
        vpTrans = new TransformGroup();//?
        vpTrans = u.getViewingPlatform().getViewPlatformTransform();
       
        //Erstelle AudioDevice wegen moeglichen Sound-Nodes
        AudioDevice audioDev = u.getViewer().createAudioDevice();       
    }   

//    public ViewingPlatform getViewingPlatform() {//getView() ex. schon in Canvas3D
//     return u.getViewingPlatform();
//    }

    public void setScene(Node node, Bounds bounds, Cursor rotateCursor) {
        //Erstelle Behavior
        PickRotateSpecial rotBehavior = new PickRotateSpecial(globalRoot,this,bounds,PickObject.USE_GEOMETRY,globalTrafo,rotateCursor);
        globalRoot.addChild(rotBehavior);//Hier Special, d.h. keine Ueberlagerung (Nicht ViewRotateSpecial, da sonst Zoom/Translate aendern!)
       
        ViewZoom zoomBehavior = new ViewZoom(this);//Aendert einfach die z-Translations-Komponente von vpTrans!
        zoomBehavior.setTransformGroup(vpTrans);
        globalRoot.addChild(zoomBehavior);
        zoomBehavior.setSchedulingBounds(bounds);
       
        //Aendert (schlecht) in x/y-Ebene von vpTrans! Special!
	ViewTranslateSpecial translateBehavior = new ViewTranslateSpecial(globalRoot,this,bounds,PickObject.USE_GEOMETRY,vpTrans);
        globalRoot.addChild(translateBehavior); 
       
        //node.setCapability( BranchGroup.ALLOW_BOUNDS_READ );//?WANN
        userScene.addChild(node);
        globalRoot.compile();
        u.addBranchGraph(globalRoot);//Mache Live
    }
/*
    public Transform3D getVpTrans3D() {
        Transform3D temp = new Transform3D();
        vpTrans.getTransform(temp);
        return temp;
    }
*/   
    public void ChangeView(Transform3D newGlobalTrafo3D, Transform3D newVpTrans3D) {
     
       /*
       Transform3D temp = new Transform3D();
       globalTrafo.getTransform(temp);
       System.out.println(temp.toString());
       vpTrans.getTransform(temp);
       System.out.println(temp.toString());     
       */

     globalTrafo.setTransform(newGlobalTrafo3D);
     vpTrans.setTransform(newVpTrans3D);  
  }
   
  public void refresh() {//Aendert nichts!
    Transform3D temp = new Transform3D();
    globalTrafo.getTransform(temp);
    globalTrafo.setTransform(temp);
  }
}
