//SubSection bestehend aus Trommel, Achse und Drehrad (Nullpunkt ist Nullpunkt Anzeigetrommel)
//Endversion 1

import com.sun.j3d.utils.geometry.*;
import javax.media.j3d.*;
import javax.vecmath.*;
import com.sun.j3d.utils.image.TextureLoader;

import java.net.URL;
import java.net.MalformedURLException;

public class SubSection extends SharedGroup {

    public SubSection(Canvas3D canvas, URL context) {
        super();
        URL url;
        TextureLoader tex;

        //Allgemein
        Vector3f vec = new Vector3f();
        Transform3D trafoMatrix = new Transform3D();

        //Erstelle Elemente mit App.
        Cylinder axis1 = new Cylinder(0.25f,7.75f,AppData.brown2A);
       
        Cylinder turnWheel = new Cylinder(3.0f,0.75f,Cylinder.GENERATE_TEXTURE_COORDS | Cylinder.GENERATE_NORMALS,AppData.brown2A);
        Appearance app1 = new Appearance();
        app1.setMaterial(MaterialData.brown2M);
       
	try {
		url = new URL(context, "textures/wswheel.jpg");
                tex = new TextureLoader(url, canvas);
                app1.setTexture(tex.getTexture());
                System.out.println(url.toString());
	     }
	     catch (MalformedURLException meme) {
	     }
       
        turnWheel.getShape(Cylinder.TOP).setAppearance(app1);
       
        Cylinder resultWheel = new Cylinder(3.5f,2.0f,Cylinder.GENERATE_TEXTURE_COORDS | Cylinder.GENERATE_NORMALS,AppData.whiteA);
        Appearance app2 = new Appearance();
        app2.setMaterial(MaterialData.whiteM);
       
	try {
		url = new URL(context, "textures/wsbarrel.jpg");
                tex = new TextureLoader(url, canvas);
                app2.setTexture(tex.getTexture());
                System.out.println(url.toString());
	     }
	     catch (MalformedURLException meme) {
	     }
       
        resultWheel.getShape(Cylinder.BODY).setAppearance(app2);

        //Setze Capabilities
        axis1.getShape(Cylinder.BOTTOM).getGeometry().setCapability(Geometry.ALLOW_INTERSECT);
        axis1.getShape(Cylinder.TOP).getGeometry().setCapability(Geometry.ALLOW_INTERSECT);
        axis1.getShape(Cylinder.BODY).getGeometry().setCapability(Geometry.ALLOW_INTERSECT);       
        turnWheel.getShape(Cylinder.BOTTOM).getGeometry().setCapability(Geometry.ALLOW_INTERSECT);
        turnWheel.getShape(Cylinder.TOP).getGeometry().setCapability(Geometry.ALLOW_INTERSECT);
        turnWheel.getShape(Cylinder.BODY).getGeometry().setCapability(Geometry.ALLOW_INTERSECT);
        resultWheel.getShape(Cylinder.BOTTOM).getGeometry().setCapability(Geometry.ALLOW_INTERSECT);
        resultWheel.getShape(Cylinder.TOP).getGeometry().setCapability(Geometry.ALLOW_INTERSECT);
        resultWheel.getShape(Cylinder.BODY).getGeometry().setCapability(Geometry.ALLOW_INTERSECT);
       
        //Setze Transformationen
        vec.set(0.0f,2.625f,0.0f);
        trafoMatrix.setTranslation(vec);
        TransformGroup tgTurnWheel = new TransformGroup(trafoMatrix);
        tgTurnWheel.addChild(turnWheel);
       
        vec.set(0.0f,-1.625f,0.0f);
        trafoMatrix.setTranslation(vec);       
        TransformGroup tgAxis1 = new TransformGroup(trafoMatrix);
        tgAxis1.addChild(axis1);
       
        this.addChild(tgAxis1);
        this.addChild(tgTurnWheel);
        this.addChild(resultWheel);//Hier Nullpkt!
    }
}
