//Applet
//Endversion 2

import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.awt.event.WindowAdapter;
import com.sun.j3d.utils.applet.MainFrame;
import javax.media.j3d.*;
import javax.vecmath.*;

import javax.swing.border.*;
import javax.swing.JPanel;
import javax.swing.BorderFactory;

import javax.swing.ImageIcon;
import javax.swing.JCheckBox;

public class WSApplet extends Applet implements ActionListener{
    private Button[] button = new Button[4];
    private Checkbox onoffCheck;
    private Checkbox texCheck;
    private Schickard schickard;
    private SceneViewer3D sceneViewer3D;
    private TextArea textArea;
    private Button resetButton;
    private JCheckBox directHelp;
   
    private Transform3D[] views = new Transform3D[4];
    private Transform3D[] rotates = new Transform3D[4];//TODO WEG NUR NOCH STARTTRAFO
   
    public void start() {
        System.out.println("Initialising applet and loading data, this will take some time ...");
       
        //Erstelle zunaechst Layout
        setLayout(new BorderLayout());

        //Erstelle Rahmen
        Border etchedBorder = BorderFactory.createEtchedBorder();
        Border emptyBorder = BorderFactory.createEmptyBorder(5,5,5,5);

        //Lade Images fuer HelpCursor, RotateCursor und ImageIcon
        Cursor helpCursor;
        Cursor rotateCursor;
        ImageIcon imageIcon;
        MediaTracker tracker = new MediaTracker(this);

        Image image1 = getImage(getCodeBase(),"textures/helpcursor.gif");//GIF wegen Transparenz
        Image image2 = getImage(getCodeBase(),"textures/helpcursor2.gif");//Ganz schwarz
        Image image3 = getImage(getCodeBase(),"textures/rotcursor.gif");       
       
        try {
	  tracker.addImage(image1,0);
          System.out.println(getCodeBase().toString() + "textures/helpcursor.gif");
	  tracker.addImage(image2,1);
          System.out.println(getCodeBase().toString() + "textures/helpcursor2.gif");
	  tracker.addImage(image3,2);
          System.out.println(getCodeBase().toString() + "textures/rotcursor.gif");
          tracker.waitForAll();

          //System.out.println(getToolkit().getMaximumCursorColors());//=2
	  //System.out.println(dimension.getWidth());//=32 Pixel
	  //System.out.println(dimension.getHeight());//=32 Pixel
          //getToolkit().prepareImage(image, (int) dimension.getWidth(), (int) dimension.getHeight(), this);//UNNOETIG
	   
	}
        catch (InterruptedException ee) {
	  helpCursor = new Cursor(Cursor.DEFAULT_CURSOR);
          rotateCursor = new Cursor(Cursor.CROSSHAIR_CURSOR);
	}

        helpCursor = getToolkit().createCustomCursor(image1, new Point(8,9), "HELP_CURSOR");
        rotateCursor = getToolkit().createCustomCursor(image3, new Point(16,16), "ROTATE_CURSOR");
        imageIcon = new ImageIcon(image2);     
       
////////TEXTAREA
        textArea = new TextArea(TextData.introduction, 5, 1, TextArea.SCROLLBARS_NONE);
        textArea.setEditable(false);
       
////////SCENEVIEWER MIT RAHMEN
        ///Erstelle globale Bounds //TODO: HIER?
        Bounds globalBounds = new BoundingSphere(new Point3d(0.0,0.0,0.0),30.0f);
       
        //Erstelle SceneViewer3D und Szene
        sceneViewer3D = new SceneViewer3D();
	schickard = new Schickard();
       
        //Verknuepft SceneViewer3D und Szene
        Node node = schickard.createScene(sceneViewer3D, globalBounds, textArea, helpCursor, getCodeBase());
        sceneViewer3D.setScene(node, globalBounds, rotateCursor);
       
        //Verhindere Clipping (!!Siehe setFrontClipDistance in API-SimpleUniverse wegen Regeln!!)
        sceneViewer3D.getView().setBackClipDistance(50.0f);//default: 10
        sceneViewer3D.getView().setFrontClipDistance(0.01f);//default: 0.1
           
        //sceneViewer3D.getView().getViewPlatform().setActivationRadius(50.0f);//default: 62
       
        //Uebergebe an Panel
        JPanel scenePanel= new JPanel(new BorderLayout());

        scenePanel.setBorder( BorderFactory.createCompoundBorder(
                              emptyBorder, BorderFactory.createTitledBorder(etchedBorder, "InteractiveScene")));
       
        scenePanel.add("Center", sceneViewer3D);
	add("Center", scenePanel);
       
////////DIRECTHELP
        directHelp = new JCheckBox("Help off", imageIcon);
        directHelp.setFocusPainted(false);
	directHelp.addItemListener(new ItemListener() {
		public void itemStateChanged(ItemEvent e) {
			if (e.getSource()==directHelp) {
			       schickard.changeHelpStatus(directHelp.isSelected());
			       if (!directHelp.isSelected()) {
			         textArea.setText("");//Damit nicht letzte Meldung stehen bleibt
				 directHelp.setText("Help off");
				 sceneViewer3D.setCursor(SceneViewer3D.default_cursor);
				 setCursor(SceneViewer3D.default_cursor);//Zur Sicherheit
			       } 
			      else {
			        directHelp.setText("Help on");
				textArea.setText("MOVE the Cursor in the InteractiveScene to get information.");
			      }
			}
		}
	});
       
////////RAHMEN UM TEXTAREA UND DIRECTHELP 
        JPanel helpPanel= new JPanel(new BorderLayout());

        helpPanel.setBorder( BorderFactory.createCompoundBorder(
                             emptyBorder, BorderFactory.createTitledBorder(etchedBorder, "Help")));

        helpPanel.add("Center", textArea);
        helpPanel.add("East", directHelp);
        add("North", helpPanel);
       
////////Erstelle Panel mit Rahmen und Viewbuttons
	JPanel controlPanel = new JPanel(new GridLayout(0,1));
       
        controlPanel.setBorder( BorderFactory.createCompoundBorder(
                                emptyBorder, BorderFactory.createTitledBorder(etchedBorder, "ControlPanel")));

	controlPanel.add(button[0] = new Button("Front View"));
	controlPanel.add(button[1] = new Button("Top View"));
	controlPanel.add(button[2] = new Button("Middle View "));
	controlPanel.add(button[3] = new Button("Bird View"));
	button[0].addActionListener(this);
	button[1].addActionListener(this);
	button[2].addActionListener(this);
	button[3].addActionListener(this);       
       
	controlPanel.add(onoffCheck = new Checkbox("Case transparent"));       
	onoffCheck.addItemListener(new ItemListener() {
		public void itemStateChanged(ItemEvent e) {
			if (e.getSource()==onoffCheck)
			       schickard.transparencyChangeCallback(onoffCheck.getState());
		}
	});
       
	controlPanel.add(texCheck = new Checkbox("Textures"));       
	texCheck.addItemListener(new ItemListener() {
		public void itemStateChanged(ItemEvent e) {
			if (e.getSource()==texCheck) {
			   schickard.textureChangeCallback(texCheck.getState());
			   sceneViewer3D.refresh();//WEGEN LINK/Sharegroups, die nicht aktualisiert werden!
			}
		}
	});
       
        controlPanel.add(resetButton = new Button("RESET!"));
        resetButton.addActionListener(this);

	add("West", controlPanel);
    
////////SICHTEN AUS SCENEVIEWER3D
        //Initialisierung
        Vector3f vec = new Vector3f();
        for(int i=0;i<4;i++){
 	  views[i] = new Transform3D();
	  rotates[i] = new Transform3D();
	  if (i==0) {
	    vec.set(0.0f,0.0f,11.12f);
	    views[0].setTranslation(vec);
            vec.set(-1.875f,0.3f,0.0f);//Genau in Mitte schieben, so dass es sich richtig dreht
	    rotates[0].setTranslation(vec);
	  }
	  else if (i==1) {
	    vec.set(1.0f,0.9f,8.5f);
	    views[1].setTranslation(vec);
	    rotates[1].rotX(Math.PI / 10.0);
	    vec.set(-1.875f,0.3f,0.0f);//Genau in Mitte schieben, so dass es sich richtig dreht
	    rotates[1].setTranslation(vec);
	  }
	  else if (i==2) {
            vec.set(1.6f,-0.42f,5.8f);//ALT: (1.6f,-0.38f,5.8f)
	    views[2].setTranslation(vec);
            vec.set(-1.875f,0.3f,0.0f);//Genau in Mitte schieben, so dass es sich richtig dreht
	    rotates[2].setTranslation(vec);	   
	  }
	  else if (i==3) {
	    vec.set(0.0f,-1.6f,4.6f);
	    views[3].setTranslation(vec);
	    rotates[3].rotX(Math.PI / 2.0);
	    vec.set(-1.875f,0.3f,0.0f);//Genau in Mitte schieben, so dass es sich richtig dreht
	    rotates[3].setTranslation(vec);
	  }
	}             

        //Standardsicht einstellen
        sceneViewer3D.ChangeView(rotates[0], views[0]);
       
        System.out.println("OK. Let's go...");
    }   

    //Falls einer der ViewButtons oder der ResetButton gedrueckt wurde
    public void actionPerformed(ActionEvent e) {
     Object o = e.getSource();

     if (o == resetButton) {
       textArea.setText(TextData.reset);
       schickard.setReset();
     }       
       
     for (int i=0;i<4;i++)
	if (o == button[i]) {
          textArea.setText(TextData.viewText[i]);
          sceneViewer3D.ChangeView(rotates[i], views[i]);
	  break;
	}              
    }   
   
    //
    // The following allows WSApplet to be run as an application
    // as well as an applet
    //
    public static void main(String[] args) {
	new MainFrame(new WSApplet(), 600, 440);
    }
}
